import 'dart:convert';
import 'dart:developer';

import 'exceptions.dart';
import 'package:dio/dio.dart';

import 'base_method.dart';

abstract class GET<T> extends BaseMethod<T> {
  Future request({
    required Function(T? data)? onSuccess,
    Function(String error)? onError,
  }) async {
    try {
      Response response = await common().get(
        url,
        queryParameters: queryParameters,
      );
      // if (!(response.statusCode! >= 200 && response.statusCode! < 300)) {
      //   DioExceptions().handleError(response.statusCode!, response.data);
      // }
      await result(
        result: response,
        onSuccess: (body) async {
          log(jsonEncode(body));
          var _onSuccess = await this.onSuccess(body: body);
          await onSuccess?.call(_onSuccess);
        },
      );
      // .then(
      //   (res) async => await result(
      //     result: res,
      //     onSuccess: (body) async {
      //       log(jsonEncode(body));
      //       var _onSuccess = await this.onSuccess(body: body);
      //       await onSuccess?.call(_onSuccess);
      //     },
      //     // onError: this.onError ?? onError
      //   ),
      // );
    } on DioError catch (error) {
      // print(error.toString());
      // DioExceptions.fromDioError(e);
      onError?.call(DioExceptions.fromDioError(error).toString());
      // catchError(
      //   error: error,
      //   onError: this.onError ?? onError,
      // );

    }
  }
}
